﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SheepFarm
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void availableSheepListView_ItemDrag(object sender, ItemDragEventArgs e)
        {
            availableSheepListView.DoDragDrop(availableSheepListView.SelectedItems,
                DragDropEffects.Copy);
        }

        private void clonedSheepListView_DragDrop(object sender, DragEventArgs e)
        {
            ListView.SelectedListViewItemCollection items = (
                e.Data.GetData(typeof(ListView.SelectedListViewItemCollection))
                as ListView.SelectedListViewItemCollection);

            foreach(ListViewItem item in items)
            {
                clonedSheepListView.Items.Add(item.Clone() as ListViewItem);
            }

            RefreshStatus();
        }

        private void clonedSheepListView_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(typeof(ListView.SelectedListViewItemCollection)))
            {
                e.Effect = DragDropEffects.Copy;
            }
        }

        private void availableSheepListView_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Control && (e.KeyCode == Keys.C))
            {
                CopySheep();
            }
        }

        private void clonedSheepListView_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Control && (e.KeyCode == Keys.V))
            {
                PasteSheep();
            }
        }

        private void CopySheep()
        {
            if (availableSheepListView.SelectedItems.Count == 1)
            {
                Clipboard.SetData("sheep", availableSheepListView.SelectedItems[0]);
            }
        }

        private void copyToolStripButton_Click(object sender, EventArgs e)
        {
            CopySheep();
        }

        private void PasteSheep()
        {
            if (Clipboard.ContainsData("sheep"))
            {
                ListViewItem sheep = Clipboard.GetData("sheep") as ListViewItem;
                clonedSheepListView.Items.Add(sheep);

                RefreshStatus();
            }
        }

        private void RefreshStatus()
        {
            sheepCountToolStripStatusLabel.Text = String.Format("Cloned Sheep: {0}",
                clonedSheepListView.Items.Count);
        }

        private void pasteToolStripButton_Click(object sender, EventArgs e)
        {
            PasteSheep();
        }
    }
}
